#ifndef dm_cand_list_H
#define dm_cand_list_H

/* A list candidates, sorted by decreasing score. */
/* Last edited on 2006-12-21 18:35:31 by stolfi */

#define dm_cand_list_H_COPYRIGHT \
  "Copyright  2006  by the State University of Campinas (UNICAMP)"

#include <dm_basic.h>
#include <dm_seq.h>
#include <dm_pairing.h>
#include <dm_cand.h>
#include <vec.h>
#include <stdint.h>

void dm_cand_list_insert
  ( dm_cand_vec_t *cdv,
    int *ncandP,
    int maxCands,
    dm_cand_t *cd,
    double frac
  );
  /* Assumes that {cdv->el[0..*ncandP-1]} is a set of candidates, sorted
    by decreasing score.  Tries to store into the {cdv} list the pairing {cd}. 
    
    The procedure is a no-op if the pairing is not among the best
    {cd.nel} entries found so far.
    
    If {frac >= 0} the procedure discards any candidate {ca} from {cd}
    or {cdv} that is mostly contained in some other candidate {cb}
    with better or equal score; where `mostly contained' means that
    the rungs of {ca} that are present in {cb} are at least {frac}
    times the number of rungs of {ca}. */

#endif
